//
//	bgrep version 1.4
//
//	@\
//		oCit@Cp^[܂B
//	RpC@
//		Visual C++
//			cl bgrep.cpp /EHsc
//		g++
//			g++ -o bgrep bgrep.cpp -std=c++0x -static -lboost_program_options -lboost_system
//	ۑ
//		E2GoCg̃t@Cւ̑Ή
//	쌠
//		̃vÓAt[\tgłB
//		widen֐ȊÓAJl_bNɒ쌠܂B
//		http://kanedaq.blog24.fc2.com/blog-entry-2.html
//
#include <stdexcept>
#include <string>
#include <iostream>
#include <fstream>
#include <iomanip>
#include <iterator>
#include <algorithm>
#include <boost/program_options.hpp>
#include <boost/filesystem/path.hpp>
#include <boost/tokenizer.hpp>

////////////////////////////////////////////////////////////////////
// widen֐́Aȉ̃y[Wq؂܂B
// http://ml.tietew.jp/cppll/cppll/article/4783
//
std::wstring
widen(const std::string& input) {
 wchar_t* buffer = new wchar_t[input.size() + 1];
 //mbstowcs(buffer, input.c_str(), input.size());
 mbstowcs(buffer, input.c_str(), input.size() + 1);
 std::wstring result = buffer;
 delete[] buffer;
 return result;
}
////////////////////////////////////////////////////////////////////

typedef unsigned char byte_t;

// [U[`̗O
class MyException : public std::runtime_error
{
public:
	explicit MyException(const std::string& msg) : std::runtime_error(msg) {}
	virtual ~MyException() throw() {}
};

// [U[`̗Oigp@\ďIƂɎgpj
class ShowUsageException : public std::runtime_error
{
public:
	ShowUsageException() : std::runtime_error("") {}
	//explicit ShowUsageException(const std::string& msg) : std::runtime_error(msg) {}
	virtual ~ShowUsageException() throw() {}
};

// 16i𐔒lɕϊ
byte_t								// 00`0F
hexchr_to_val(
	std::string::value_type chr		// '0'`'F'
) throw(MyException)
{
	if ('0' <= chr && chr <= '9') {
		return static_cast<byte_t>(chr - '0');
	}
	else if ('a' <= chr && chr <= 'f') {
		return static_cast<byte_t>(10 + chr - 'a');
	}
	else if ('A' <= chr && chr <= 'F') {
		return static_cast<byte_t>(10 + chr - 'A');
	}
	else {
		throw MyException(std::string("illegal character '") + chr + '\'');
	}
}

// oCit@Cp^[
template <class PatternType, typename Function>
bool								// trueFAfalseFȂ
search_in_file(
	std::ifstream& fi,				// oCit@C
	const PatternType& pattern,		// p^[ioCg̃Reij
	bool quick,						// trueF1ł珈IAfalseFS
	Function call_if_found			// ƂɌĂ΂֐
) throw(MyException)
{
	static_assert(sizeof(typename PatternType::value_type) == 1, "invalid size - PatternType::value_type.");
	static const size_t BUFSIZE = 65536;
	static typename PatternType::value_type buf[BUFSIZE];		// t@C炱̃obt@ɓǂݍ

	// p^[̒[ȂAȂƂ݂Ȃ
	if (pattern.empty()) {
		return false;
	}

	// p^[G[ɂ
	const size_t pattern_size = pattern.size();
	if (pattern_size <= BUFSIZE / 10) {		// (BUFSIZE / 10)ɓʂȈӖ͂Ȃ
		;
	}
	else {
		throw MyException("pattern too long");
	}

	typename PatternType::value_type* const read_buf_pos = buf + (pattern_size - 1);	// t@C炱̃obt@̈ʒuɓǂݍ
	const int read_size = BUFSIZE - (pattern_size - 1);									// t@CǂݍރoCg

	bool result = false;
	size_t read_file_pos = 0;	// ǂݍ񂾃f[^́At@C擪̈ʒuip^[Ƃ̈ʒǔvZɎgpj
	fi.read(reinterpret_cast<char* const>(read_buf_pos), read_size);
	const typename PatternType::value_type* first = read_buf_pos;	// obt@̌Jnʒui͓ǂݍ񂾈ʒu猟j
	while (fi.gcount()) {
		const typename PatternType::value_type* last = read_buf_pos + fi.gcount();		// obt@̌Iʒu
		while (last != (first = std::search(first, last, pattern.begin(), pattern.end()))) {
			// Ƃ̏
			const size_t found_fpos_zero_origin = first - read_buf_pos + read_file_pos;	// Ƃ́At@C擪̈ʒu
			call_if_found(found_fpos_zero_origin);

			if (quick) {
				return true;
			}
			result = true;
			++first;		// ʒu1oCg납
		}
		read_file_pos += fi.gcount();
		std::copy(last - (pattern_size - 1), last, buf);					// obt@̖擪ɃRs[āDD
		fi.read(reinterpret_cast<char* const>(read_buf_pos), read_size);	// Rs[̈ʒuɓǂݍ
		first = buf;														// obt@̐擪猟
	}
	return result;
}

// C
int main(int argc, char* argv[])
{
	namespace po = boost::program_options;
	namespace fs = boost::filesystem;

	// nCttIvV`
	po::options_description opt_hyphen("Options");

	try {
		setlocale(LC_CTYPE, "");

		opt_hyphen.add_options()
			("string,s" , "string search <default>")
			("wstring,w", "wstring search")
			("hex,h"    , "hex search")
			("list,l"   , "list match files")
			("verbose,v", "display messages")
		;

		// nCtȂIvV`
		po::options_description opt_pattern_and_files("Command arguments");
		opt_pattern_and_files.add_options()
			("pattern_and_files", po::value<std::vector<std::string>>(), "pattern and files")
		;

		po::positional_options_description posi;
		posi.add("pattern_and_files", -1);

		// SIvV variables_mapɊi[
		po::variables_map varmap;
		po::options_description full("All options");
		full.add(opt_hyphen).add(opt_pattern_and_files);

		po::store(po::command_line_parser(argc, argv).options(full).positional(posi).run(), varmap);
		po::notify(varmap);

		// nCttIvV̎o
		int opt_string  = varmap.count("string");
		int opt_wstring = varmap.count("wstring");
		int opt_hex     = varmap.count("hex");

		switch (opt_string + opt_wstring + opt_hex) {
		case 0:
			opt_string = 1;		// ftHg""
			break;
		case 1:
			break;
		default:
			throw MyException("options contradict");
		}

		const bool opt_list_files = (varmap.count("list") != 0);
		const bool opt_verbose = (varmap.count("verbose") != 0);

		// R}hC̕\
		if (opt_verbose) {
			//std::copy(argv, argv + argc, std::ostream_iterator<const char*>(std::cout, " "));
			std::for_each(argv, argv + argc, [](const char* arg)
				{
					if (strchr(arg, ' ') != NULL) {
						// Xy[X܂ވ́A_uNH[e[Vň͂ĕ\
						std::cout << '\"' << arg << '\"';
					}
					else {
						std::cout << arg;
					}
					std::cout << ' ';
				}
			);
			std::cout << "\n\n";
		}

		// nCtȂIvV̎o
		if (varmap.count("pattern_and_files")) {
			;
		}
		else {
			throw ShowUsageException();
		}
		const std::vector<std::string>& pattern_and_files(varmap["pattern_and_files"].as<std::vector<std::string>>());
		if (2 <= pattern_and_files.size()) {
			;
		}
		else {
			throw MyException("short of parameter");
		}

		// nCtȂIvV1Ԗڂ́Ap^[
		std::vector<std::string>::const_iterator itr = pattern_and_files.begin();
		const std::string& pattern_arg(*itr);

		// ȌAl16i\
		std::cout << std::hex << std::setiosflags(std::ios::uppercase);

		///////// IvVɉČp^[ϊA16i\

		std::vector<byte_t> byte_array;		// ϊ̃oCgi[Rei

		if (opt_verbose) {
			// ̎ށiAChA16ij̕\
			std::cout << "search option: ";
			if (opt_string) {
				std::cout << "[string] wstring hex\n";
			}
			else if (opt_wstring) {
				std::cout << "string [wstring] hex\n";
			}
			else {
				std::cout << "string wstring [hex]\n";
			}

			// p^[̕\
			std::cout << "pattern (arg): " << pattern_arg << '\n';
			std::cout << "pattern (hex): ";
		}

		if (opt_string) {			// T
			// p^[16i\
			if (opt_verbose) {
				//std::copy(pattern_arg.begin(), pattern_arg.end(), std::ostream_iterator<byte_t>(std::cout, " "));
				std::for_each(pattern_arg.begin(), pattern_arg.end(), [](byte_t chr) { std::cout << static_cast<unsigned int>(chr) << ' '; });
			}

		}
		else {
			if (opt_wstring) {		// ChɕϊČ
				// stringwstringɕϊ
				std::wstring wstr(widen(pattern_arg));

				// wstringoCg̃Reiɕϊ
				byte_array.reserve(wstr.size() * sizeof(std::wstring::value_type));
				std::for_each(wstr.begin(), wstr.end(), [&byte_array](const std::wstring::value_type& value)
					{
						auto pp = reinterpret_cast<const byte_t*>(&value);
						std::copy(pp, pp + sizeof(std::wstring::value_type), std::back_inserter(byte_array));
					}
				);

			}
			else {				// 16iT
				// 16ioCif[^ɕϊ
#if 0
				std::istringstream is(pattern_arg);
				std::string hexstr;
				while (is >> hexstr) {
					byte_t hex;

					switch (hexstr.size()) {
					case 1:
						hex = hexchr_to_val(hexstr[0]);
						break;
					case 2:
						{
							const unsigned int high = hexchr_to_val(hexstr[0]);
							const unsigned int low  = hexchr_to_val(hexstr[1]);
							hex = static_cast<byte_t>((high << 4) | low);
						}
						break;
					default:
						throw MyException("An illegal hexFThere are 3 characters and more tokens.");
					}

					byte_array.push_back(hex);
				}
#else
				// boost::tokenizergďĂ݂
				boost::char_separator<char> sep(" \t\n");
				boost::tokenizer<boost::char_separator<char>> tokens(pattern_arg, sep);
				std::transform(tokens.begin(), tokens.end(), std::back_inserter(byte_array)
					, [](const std::string& hexstr) -> byte_t
					{
						if (hexstr.size() == 1 || hexstr.size() == 2) {
							try {
								if (hexstr.size() == 1) {
									return hexchr_to_val(hexstr[0]);
								}
								else {
									const unsigned int high = hexchr_to_val(hexstr[0]);
									const unsigned int low  = hexchr_to_val(hexstr[1]);
									return static_cast<byte_t>((high << 4) | low);
								}
							}
							catch (MyException& ex) {
								throw MyException("illegal hex string: \"" + hexstr + "\" -> " + ex.what());
							}
						}
						else {
							throw MyException("illegal hex string: \"" + hexstr + "\" -> there are 3 characters and more tokens");
						}
					}
				);
#endif
			}

			// p^[16i\
			if (opt_verbose) {
				//std::copy(byte_array.begin(), byte_array.end(), std::ostream_iterator<byte_t>(std::cout, " "));
				std::for_each(byte_array.begin(), byte_array.end(), [](byte_t chr) { std::cout << static_cast<unsigned int>(chr) << ' '; });
			}
		}

		if (opt_verbose) {
			std::cout << "\n----------(begin)----------\n";
		}

		// nCtȂIvV2Ԗڈȍ~́At@C
		for (++itr; itr != pattern_and_files.end(); ++itr) {
			const std::string& filename(*itr);

			// t@CI[v
			//std::ifstream fi(filename.c_str(), std::ios::nocreate | std::ios::binary);
			std::ifstream fi(filename.c_str(), std::ios::binary);
			if (fi) {
				;
			}
			else {
				throw MyException("could not open \"" + filename + '"');
			}

			// p^[ƂÅ֐ŕ\
			auto print_if_found = [&filename, opt_list_files](size_t fpos_zero_origin)
			{
				std::cout << filename;
				if (opt_list_files) {
					// -lIvVw肳ꂽƂ́At@Ĉݕ\
					;
				}
				else {
					// -lIvVw肳ȂƂ́At@Cƃt@C擪̈ʒu\
					std::cout << ": " << fpos_zero_origin;
				}
				std::cout << std::endl;
			};

			if (opt_string) {
				// ^ꂽp^[Â܂ܕƂČ
				search_in_file(fi, pattern_arg, opt_list_files, print_if_found);
			}
			else {
				// ^ꂽp^[ϊAoCg̃ReiT
				search_in_file(fi, byte_array, opt_list_files, print_if_found);
			}
		}
		if (opt_verbose) {
			std::cout << "-----------(end)-----------" << std::endl;
		}
	}
	catch (ShowUsageException& ex) {
		if (ex.what()[0]) {
			std::cerr << "Error: " << ex.what() << '\n' << std::endl;
		}
		std::cout << "bgrep Version 1.4 Copyright (c) 2011 kanedaq\n";
		std::cout << "Usage: bgrep [-swhlv] pattern file[s]\n";
		std::cout << opt_hyphen;
		std::cout << "Usage examples:\n";
		std::cout << "    (Unix) find . -type f -name '*' -print0 | xargs -0 bgrep pattern\n";
		std::cout << "    (Windows) dir /b /a-d /s * | xargs bgrep pattern" << std::endl;
		return 1;
	}
	catch (std::exception& ex) {
		std::cerr << "Error: " << ex.what() << std::endl;
		return 1;
	}

	return 0;
}
